#include <boost/noncopyable.hpp>

#ifndef CME_FAST_GROUP_FIELD_DEFINITION_H_
#define CME_FAST_GROUP_FIELD_DEFINITION_H_

#include "FieldDefinition.h"
#include "../values/CValues.h"
#include "../Codec.h"

namespace FAST
{

class GroupFieldDefinition : public FieldDefinition
{
  private:
    bool presence_map;
    Codec& group_codec;
    CuInt32 group_length;
    string parsed_value;
    
  public:
    GroupFieldDefinition(int id, int type, int op, int tid, int s, Codec& codec, bool optional);
    virtual ~GroupFieldDefinition() {}
    
    virtual void set_current_value(Codec& codec, const string& data) {
      CuInt32::type default_value = CuInt32::parse(data);
      if (get_field_operator() == FieldDefinition::OPERATOR_INCREMENT) --default_value;
      set_default_value(true);
      codec.get_current_values().set_u32(get_slot(), default_value);
    }
    
    virtual void reset_data() { group_codec.reset_dictionary(); }
    virtual CData* get_data() { return 0; }
    virtual string get_value() { return parsed_value; }
    virtual string decode(const int slot, Codec& codec);
	virtual void decode(const int slot, Codec& codec, CFIXMessageEventHandlerContainer& eventHandlerContainer);
    
    bool has_presence_map() const { return presence_map; }
    void set_presence_map(const bool value) { presence_map = value; }
    Codec& get_group_codec() { return group_codec; }
};

}

#endif /*CME_FAST_GROUP_FIELD_DEFINITION_H_*/
