#include <boost/noncopyable.hpp>

#ifndef CME_FAST_SCALED_MANTISSA_FIELD_DEFINITION_H_
#define CME_FAST_SCALED_MANTISSA_FIELD_DEFINITION_H_

#include "IntFieldDefinition.h"

namespace FAST
{

class ScaledMantissaFieldDefinition : public I64FieldDefinition
{
  private:
    bool optional_decimal;
    
  public:
    ScaledMantissaFieldDefinition(const int id, const int type, const int op, 
      const int tid, const int s, const bool optional, const bool optionalDec)
        : I64FieldDefinition(id, type, op, tid, s, optional), 
          optional_decimal(optionalDec) {}
    
    virtual ~ScaledMantissaFieldDefinition() {}
    
    virtual string decode(const int slot, Codec& codec);
	virtual void decode(const int slot, Codec& codec, CFIXMessageEventHandlerContainer& eventHandlerContainer);
};

}

#endif /*CME_FAST_SCALED_MANTISSA_FIELD_DEFINITION_H_*/
