#include "stdafx.h"
#include "FASTDecoder.h"

namespace FAST
{

bool Decoder::LOGME = false;


Decoder::Decoder() {
  // nothing to do!
}


Decoder::~Decoder() {
  // nothing to do!
}


string Decoder::decode_message()
{
  std::string strout;
  strout.reserve(256);
  vector<Codec *> used;
  CBytesPtr pmap = codec->get_presence_map_off_stream();

  while (pmap->get_length() > 0)
  {
    codec->parse_pmap(pmap, true, 0, true);

    // Parse the template id
    U32FieldDefinition* template_field = 
      (U32FieldDefinition *) (codec->get_definitions()[0]);

    template_field->decode(0, *codec);
    string templateId = template_field->get_value();

    if (Decoder::LOGME)
	{
      FLogger::get_instance().append_buffer("Received templateID: ");
      FLogger::get_instance().append_buffer(templateId.c_str());
      FLogger::get_instance().print_buffer();
      FLogger::get_instance().reset_buffer();
    }

    //Switch Templates
    if (codec->get_template_id() != ((CuInt32 *) template_field->get_data())->get_value())
	{
      codec = templates[templateId];
      if (Decoder::LOGME) FLogger::get_instance().reset_buffer();
    }
    
    codec->parse_pmap(pmap, true, 0, false);

    //Log the presence map & template id
    if (Decoder::LOGME) {
      FLogger::get_instance().print_buffer();
      FLogger::get_instance().reset_buffer();
      FLogger::get_instance().print_header();
      FLogger::get_instance().pretty_print_display();
      FLogger::get_instance().reset();
    }
    
    vector<FieldDefinition *>& fieldDefinitions = codec->get_definitions();
    for (unsigned int i=1; i<fieldDefinitions.size(); ++i) {
		strout.append(fieldDefinitions[i]->decode(i, *codec));
    }
    
    if (Decoder::LOGME)
		FLogger::get_instance().println();
    
    used.push_back(codec);
    pmap = codec->get_presence_map_off_stream();
  }
  
  // clear dictionary after a batch.
  for (vector<Codec *>::iterator i = used.begin(), e = used.end(); i != e; ++i) {
    (*i)->reset_dictionary();
  }
  used.clear();

  return strout;
}

}