#ifndef CME_FAST_SAMPLE_DECODER_H_
#define CME_FAST_SAMPLE_DECODER_H_

#include <string>
#include <map>
#include <boost/noncopyable.hpp>

#include "TransferEncoder.h"
#include "Decoder.h"


using std::string;

namespace FAST
{

/**
 * This class provides a very simple implementation of the CME Group C++
 * FIX FAST decoder.  You may use it as is or extend it to add whatever
 * functionality you desire.  This is intended as a starting point for most.
 */
class SampleDecoder : public Decoder
{
  public:
    static const string VERSION;
    static string get_version();

  public:
    SampleDecoder(const string& template_file);
    void decoderit(const string& data_file);
	void decode_message(const char* msg, int bufferSize);
	std::string decode_message_to_string(const char* msg, int bufferSize);
    virtual ~SampleDecoder() {}

  private:
	TemplateBuilder m_templateBuilder;
	TransferEncoder m_transferEncoder;

};

}

#endif /*CME_FAST_SAMPLE_DECODER_H_*/

