#include "../FASTDecoder.h"


namespace FAST
{

void CDecimal::set_value(const string& value) {
  CValue<string>::set_value(value);
  const string::size_type dot = value.find_first_of('.');
  _mantissa = CInt64::parse(dot == string::npos ? value : string(value).erase(dot, 1));
  _exponent = (dot == string::npos) ? 0 : (1 - value.length() + dot);
}

static string decimalToString (__int64 mantissa, __int32 exponent)
{
    if (mantissa > 0)
    {
		char buf[30];
		_i64toa_s (mantissa, buf, sizeof(buf), 10);
		string out (buf);
        if (exponent == 0)
		{
            return out;
		}
        else if (exponent > 0) 
		{
            return out + string (exponent, '0');
		}
        else 
        {
            int index = out.size() + exponent;
            if (index == 0)
                return "0." + out;
            else if (index > 0)
                return out.insert (index, ".");
            else
                return "0." + string (-index, '0') + out;
        }
    } 
    else if (mantissa < 0)
    {
        return "-" + decimalToString (-mantissa, exponent);
    } 
    else
        return "0";
}

string CDecimal::get_decimal() const {
	return decimalToString (_mantissa, _exponent);
}


ostream& operator << (ostream& out, const CDecimal& decimal) {
  return decimal.insert(out);
}

}