#pragma once

#ifndef __CMARKETDATAMESSAGEEVENTHANDLER_H__
#define __CMARKETDATAMESSAGEEVENTHANDLER_H__

#include "FIXMessageEventHandler.h"
#include "FIXMessageProcessDispatcher.h"

#include <sstream>

namespace BmfMessagingPlugin
{
	class  CMarketDataMessageEventHandler :
		public FAST::IFIXMessageEventHandler
	{
	public:
		CMarketDataMessageEventHandler(TFIXMessageProcessDispatcherWeakPtr wpMessageProcessDispatcher);
		virtual ~CMarketDataMessageEventHandler(void);

		// Event callbacks
		virtual void onMessageBegin(int channelID, unsigned int sourceID);
		virtual void onMessageEnd(int channelID, unsigned int sourceID);
		virtual void onField(int fieldID, const std::string& value);
		virtual void onRepeatingGroupBegin(int fieldID, unsigned int size);
		virtual void onRepeatingGroupEnd(int fieldID);
		virtual void onRepeatingGroupItemBegin(int slot);
		virtual void onRepeatingGroupItemEnd(int slot);
		virtual void onGroupBegin(int fieldID, int groupNo);
		virtual void onGroupEnd(int fieldID);

	private:
		TFIXMessageProcessDispatcherWeakPtr m_wpMessageProcessDispatcher;
		int m_channelID;
		unsigned int m_sourceID;

		std::stringstream m_rawMessage;
		std::stringstream m_events;
	};

}

#endif	// __CMARKETDATAMESSAGEEVENTHANDLER_H__